# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime
from .. import utilities

class IAMPolicy(pulumi.CustomResource):
    """
    Allows creation and management of the IAM policy for an existing Google Cloud
    Platform folder.
    """
    def __init__(__self__, __name__, __opts__=None, folder=None, policy_data=None):
        """Create a IAMPolicy resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not folder:
            raise TypeError('Missing required property folder')
        elif not isinstance(folder, basestring):
            raise TypeError('Expected property folder to be a basestring')
        __self__.folder = folder
        """
        The resource name of the folder the policy is attached to. Its format is folders/{folder_id}.
        """
        __props__['folder'] = folder

        if not policy_data:
            raise TypeError('Missing required property policy_data')
        elif not isinstance(policy_data, basestring):
            raise TypeError('Expected property policy_data to be a basestring')
        __self__.policy_data = policy_data
        """
        The `google_iam_policy` data source that represents
        the IAM policy that will be applied to the folder. This policy overrides any existing
        policy applied to the folder.
        """
        __props__['policyData'] = policy_data

        __self__.etag = pulumi.runtime.UNKNOWN
        """
        (Computed) The etag of the folder's IAM policy. `etag` is used for optimistic concurrency control as a way to help prevent simultaneous updates of a policy from overwriting each other. 
        """

        super(IAMPolicy, __self__).__init__(
            'gcp:folder/iAMPolicy:IAMPolicy',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'etag' in outs:
            self.etag = outs['etag']
        if 'folder' in outs:
            self.folder = outs['folder']
        if 'policyData' in outs:
            self.policy_data = outs['policyData']
